
require 'conjur/api'
require 'conjur/cli'
require 'conjur/authn'

netrc = Conjur::Authn.netrc
credentials = Conjur::Authn.get_credentials
username = credentials[0]
puts "Logging in as #{username}"

Before('@conjurapi-log') do
  set_env 'CONJURAPI_LOG', 'stderr'
end

Before do
  @admin_api = conjur_api = Conjur::API.new_from_key username, credentials[1]
  
  @namespace = conjur_api.create_variable("text/plain", "id").id
  user = conjur_api.create_user "admin@#{@namespace}", ownerid: "#{Conjur.configuration.account}:user:#{username}"

  conjur_api = conjur_api = Conjur::API.new_from_key user.username, user.api_key
  @security_admin = conjur_api.create_group [ @namespace, "security_admin" ].join('/')
  @security_admin.add_member user, admin_option: true
  
  JsonSpec.memorize "MY_ROLEID", %Q("#{user.roleid}")
  
  @aruba_timeout_seconds = 10
end

After do
  tempfiles.each { |tempfile| File.unlink(tempfile) unless tempfile.nil? }
end
