module ConjurCLIWorld
  def last_json
    stdout_from(@last_cmd)
  end
  
  def find_or_create_password(username)
    @passwords ||= {}
    unless password = @passwords[username] 
      password = @passwords[username] = SecureRandom.hex(12)
    end
    password
  end

  def namespace
    @namespace or raise "@namespace is not initialized"
  end
  
  def run_simple(cmd, fail_on_error=true, timeout = nil)
    cmd = process_cmd(cmd)
    
    super cmd, fail_on_error, timeout
    
    puts stderr_from(cmd)
    puts stdout_from(cmd)
  end

  def run_interactive(cmd)
    cmd = process_cmd(cmd)
    
    super cmd

    puts stderr_from(cmd)
    puts stdout_from(cmd)
  end  
  
  # Substitute the namespace for marker $ns
  def unescape(string)
    string = super
    string.gsub("$ns", namespace)
  end
  
  def get_process(wanted)
    super wanted.gsub("$ns", namespace)
  end

  def tempfiles 
    @tempfiles||=[]
  end       
 
  protected
  
  def process_cmd(cmd)
    cmd.gsub!("$ns", namespace)
    cmd.gsub!("$pubkeys_url", Conjur.configuration.pubkeys_url)
    
    @last_cmd = cmd
    JsonSpec.memory.each do |k,v|
      cmd.gsub!("%{#{k}}", v)
    end
    cmd
  end
end

World(ConjurCLIWorld)
